--based on https://love2d.org/wiki/love.graphics.stencil
function love.load()
	pic = love.graphics.newImage("lokjpg60.jpg")
	mask = love.graphics.newImage("lokpng.png")

end
-- a black/white mask image: black pixels will mask, white pixels will pass.
local mask = love.graphics.newImage("lokpng.png")

local mask_shader = love.graphics.newShader[[
   vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
      if (Texel(texture, texture_coords).rgb == vec3(0.0)) {
         // a discarded pixel wont be applied as the stencil.
         discard;
      }
      return vec4(1.0);
   }
]]

local function myStencilFunction()
   love.graphics.setShader(mask_shader)
   love.graphics.draw(mask, 0, 0)
   love.graphics.setShader()
end

function love.draw()
	--background
    local t = love.timer.getTime()
    love.graphics.setColor (math.sin(t)+0.5,math.cos(t*3)+0.5, 0,1)
    love.graphics.rectangle("fill",0 ,0, 800, 600)

	love.graphics.scale (0.25,0.25) --photos are too large to fit on 800x600 window
    --mask
    love.graphics.stencil(myStencilFunction, "replace", 1)
    love.graphics.setStencilTest("less", 1)
    love.graphics.setColor (1,1,1,1)
    --photo
    love.graphics.draw(pic, 0, 0)
    love.graphics.setStencilTest()
end
